#ifndef KBAG_H
#define KBAG_H

#include <sys/stat.h>
#include <kapp.h>
#include <ktmainwindow.h>
#include <qmenubar.h>
#include <qlistbox.h>
#include <ktoolbar.h>
#include "mydatabase.h"
#include "kmainlist.h"

class KBag : public KTMainWindow {
  Q_OBJECT 
public: 
  KBag(QWidget*parent=0,const char* name=0);
  ~KBag();

  KConfig	*MyConfig;
  QString *compression; 		  // compression programm as gzip or bzip2.
  QString *floppy_mount;		  // mount point to floppy
  QString *removable_mount;	  // mount point to removable
  QString *hard_mount;			  // mount point to harddrive
  QStrList	*list_names;			// list of item's names
  QStrList	*list_folders; 	  // list of item's folder
  QStrList	*list_targets;		// list of item's target (to floppy, remov...)
	KMainList	*list;						//
  QPopupMenu	*popup_menu;
  int     how_add;            // flag: add or options... (KItem)
public slots:
  void exit(void);
  void about(void);
  void help_manual(void);
  void preference(void);
  void add_item(void);
  void opt_item(void);
  void del_item(void);
  void item_to(void);
  void item_from(void);
  void recalc(void);
protected:
  int datafile;                 // datat file description
  QList<MyDatabase> datalist;   // QList with data (from database)
  struct stat stat_buf;         // buffer for stat command (man 2 stat)
  long templong;                // temp. long int (32 bits)
  char* exec_argv[1024];        // parameters for execvp (up to 1024)
  int   exec_argc;              // counter for argv
  int pid;                      // pid for child process
  int status;                   // return value for waitpid
	
	virtual void resizeEvent ( QResizeEvent * e);
	void recalc_add_folder(const char* path);
	void item_to_add_folder(const char* path);
};

#ifndef MAIN_CPP
extern KBag*kbag;
#endif

#endif





















