/***************************************************************************
                   kitem.cpp  -  dialog for Bag's options
                             -------------------                                         
    begin                : Tue Aug 24 1999                                           
    copyright            : (C) 1999 by Kir Smirnov                         
    email                : ksm@mail.ru                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#include <kfiledialog.h>
#include "kbag.h"
#include "kitem.h"
#include <qmessagebox.h>

KItem::KItem(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
	connect( QPushButton_1, SIGNAL(clicked()), SLOT(save()));
	connect( QPushButton_2, SIGNAL(clicked()), SLOT(cancel()));
	connect( QPushButton_3, SIGNAL(clicked()), SLOT(select()));
	
	QComboBox_1->insertItem("floppy");
	QComboBox_1->insertItem("removable");
	QComboBox_1->insertItem("hard drive");
	
	if (kbag->how_add!=1)
		{
  	setCaption(i18n("kBag - change options for existing bag"));
		QLineEdit_1->setText(kbag->list_names	  ->at(kbag->list->currentItem()));
		QLineEdit_2->setText(kbag->list_folders ->at(kbag->list->currentItem()));
		QComboBox_1->setCurrentItem(atoi(kbag->list_targets ->at(kbag->list->currentItem())));
		}
	else
	  {
  	setCaption(i18n("kBag - add new bag"));
		QLineEdit_1->setText("");
		QLineEdit_2->setText("");
	  }
}

KItem::~KItem(){
}

void KItem::save(void){
  if (strlen(QLineEdit_1->text())==0) return;
  if (strchr(QLineEdit_1->text(), ',')!=0) return; // we don't like ',' (KConfig)
  if (strlen(QLineEdit_2->text())==0) return;
save_100:
  if (QLineEdit_2->text()[strlen(QLineEdit_2->text())-1]=='/')
  	{
		QLineEdit_2->setMaxLength(strlen(QLineEdit_2->text())-1);
		QLineEdit_2->setMaxLength(255);
		goto save_100;
		}
  if (kbag->how_add==1)
    {
    kbag->list_names  ->append(QLineEdit_1->text());
    kbag->list_folders->append(QLineEdit_2->text());
    QString *tempstr = new QString;
    tempstr->sprintf("%d", QComboBox_1->currentItem());
    kbag->list_targets->append(tempstr->data());
    }
  else
    {
    if (strcmp(kbag->list_folders->at(kbag->list->currentItem()),
      QLineEdit_2->text())!=0) kbag->how_add=1; // root dir changed - recalc needed !
    kbag->list_names  ->remove(kbag->list->currentItem());
    kbag->list_folders->remove(kbag->list->currentItem());
    kbag->list_targets->remove(kbag->list->currentItem());
    kbag->list_names  ->insert(kbag->list->currentItem(), QLineEdit_1->text());
    kbag->list_folders->insert(kbag->list->currentItem(), QLineEdit_2->text());
    QString *tempstr = new QString;
    tempstr->sprintf("%d", QComboBox_1->currentItem());
    kbag->list_targets->insert(kbag->list->currentItem(), tempstr->data());
    }
  // recalc new database (if add or dir changed!)
 	kbag->list->clear();
  kbag->list->insertStrList(kbag->list_names);
  if (kbag->how_add==1)
    {
    kbag->list->setCurrentItem(kbag->list->count()-1);
    kbag->recalc();
    }
  close();
}

void KItem::cancel(void){
  reject();
}

void KItem::select(void){
  QString* tempstr = new QString(KDirDialog::getDirectory(QLineEdit_2->text()));
  if (!tempstr->isEmpty())
    QLineEdit_2->setText(tempstr->data());
}
